﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Brick : MonoBehaviour
{
    private int timesHit;
    private LevelManager levelManager;
    private bool isBreakable;

    public Sprite[] HitSprites;
    public static int breakableCount = 0;
    public AudioClip crack;
    public GameObject smoke;
    public GameObject smokePuff;

    // Use this for initialization
    void Start()
    {
        levelManager = FindObjectOfType<LevelManager>();
        isBreakable = (this.tag == "Breakable");
        if (isBreakable)
        {
            breakableCount += 1;
        }
        timesHit = 0;
    }

    // Update is called once per frame
    void Update()
    {

    }

    // Collision Detection
    void OnCollisionEnter2D(Collision2D collision)
    {
        AudioSource.PlayClipAtPoint(crack, transform.position, 1.5f);
        if (isBreakable)    {  HandleHits();  }
    }

    void HandleHits()
    {
        timesHit += 1;
        int maxHits;
        maxHits = HitSprites.Length + 1;
        if (timesHit >= maxHits)
        {
            breakableCount -= 1;
            
            levelManager.BrickDestroyed();
            SmokePuff();

            Destroy(gameObject);
        }
        else {
            LoadSprites();
        }
    }

    private void SmokePuff()
    {
        GameObject smokePuff = Instantiate(smoke, gameObject.transform.position, Quaternion.identity);
        ParticleSystem.MainModule main = smokePuff.GetComponent<ParticleSystem>().main;
        main.startColor = GetComponent<SpriteRenderer>().color;
    }

    private void LoadSprites()
    {
        int spriteIndex = timesHit - 1;
        if (HitSprites[spriteIndex] != null)
        {
            this.GetComponent<SpriteRenderer>().sprite = HitSprites[spriteIndex];
        }
        else
        {
            Debug.LogError("Brick Sprite Missing");
        }
            
    }

    //// TO DO Remove this method once we can actually win.  
    //void SimulateWin()
    //{
    //    levelManager.LoadNextLevel();
    //}
}
